SystemOrganization addCategory: #'Pier-SW2-Sw1Features'!

!PRViewRenderer methodsFor: '*pier-sw2-sw1features' stamp: 'JohnBorden 8/24/2011 17:17'!
visitPierTable: anObject
	| table |
	(table := html table) attributes addClass: 'prtable'.
	table with: [ super visitTable: anObject ]! !

!PRVisitor methodsFor: '*Pier-SW2-Sw1Features' stamp: 'JohnBorden 8/24/2011 17:15'!
visitPierTable: anObject
	self visitTable: anObject! !

!PRTable methodsFor: '*Pier-SW2-Sw1Features' stamp: 'JohnBorden 8/24/2011 17:18'!
accept: aVisitor
	aVisitor visitPierTable: self! !

!PRSearchView methodsFor: '*Pier-SW2-Sw1Features' stamp: 'JohnBorden 8/24/2011 20:40'!
refresh
	| searcher |
	items := OrderedCollection new.
	self hasValidQuery ifFalse: [ ^ self ].
	searcher := self context structure fullTextSearch.
	(self query findTokens: Character space) do: [ :token | 
		(token notEmpty and: [ token first = $+ ]) 
			ifTrue: [ searcher acceptToken: token allButFirst ]
			ifFalse: [
				(token notEmpty and: [ token first = $- ]) 
					ifTrue: [ searcher rejectToken: token allButFirst ]
					ifFalse: [ searcher acceptToken: token ] ] ].
	self items addAll: (searcher select: [ :structure | 
		structure parents allSatisfy: [ :parent | 
			(self context structure: parent) isValid ] ])! !

PRNavigationWidget subclass: #PRPathNavigationWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRPathNavigationWidget commentStamp: 'JohnBorden 8/4/2011 20:56' prior: 0!
PRPathNavigationWidget is a widget that displays the link path to the current structure, as links (like / parent / child / thisPage).
!

!PRPathNavigationWidget class methodsFor: 'accessing' stamp: 'JCB 3/1/2009 21:10'!
label
	^ 'Link Path'! !

!PRPathNavigationWidget methodsFor: 'rendering' stamp: 'JohnBorden 8/24/2011 21:30'!
renderParents: aCollection on: html
	| active path |
	active := self isActive: aCollection first.
	path := active and: [ self selected parents includes: aCollection first ].
	(html anchor)
		class: 'path' if: path;
		class: 'active' if: active;
		goto: (self context structure: aCollection first);
		with: '/'.
	aCollection allButFirst do: [ :e | self renderItem: e on: html ] separatedBy: [ html text: '/' ]! !

PRObjectTest subclass: #Pier1ToPier2ConverterTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!Pier1ToPier2ConverterTest commentStamp: 'JohnBorden 8/24/2011 21:33' prior: 0!
Pier1ToPier2ConverterTest is modeled after PRKernelTest

Instance Variables:
	kernel	PRKernel!

!Pier1ToPier2ConverterTest class methodsFor: 'testing' stamp: 'JohnBorden 8/13/2011 21:46'!
isAbstract
	^ false! !

!Pier1ToPier2ConverterTest methodsFor: 'accessing' stamp: 'JohnBorden 8/13/2011 21:53'!
actualClass
	^ PRKernel! !

!Pier1ToPier2ConverterTest methodsFor: 'accessing' stamp: 'JohnBorden 8/13/2011 21:49'!
instance
	^ self kernel! !

!Pier1ToPier2ConverterTest methodsFor: 'accessing' stamp: 'JohnBorden 8/13/2011 21:50'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!Pier1ToPier2ConverterTest methodsFor: 'tests' stamp: 'JCB 4/30/2011 22:46'!
testConvertAmpersandString
	self
		assert:
			(Pier1ToPier2Converter new convertString: 'This contains & as well as &#42; in it.')
				= 'This contains & as well as {{{&#42;}}} in it.'.
	self
		assert:
			(Pier1ToPier2Converter new convertString: 'This contains &LT; as well as &gT; in it.')
				= 'This contains {{{&LT;}}} as well as {{{&gT;}}} in it.'! !

!Pier1ToPier2ConverterTest methodsFor: 'tests' stamp: 'JohnBorden 8/13/2011 22:22'!
testConvertPage
	| converter |
	self kernel root contents: 'This is a *link to this page>./*'.
	converter := Pier1ToPier2Converter new kernel: self kernel.
	converter convertPage: self kernel root.
	self assert: self kernel root contents = 'This is a *link to this page>./*'! !

!Pier1ToPier2ConverterTest methodsFor: 'tests' stamp: 'JohnBorden 8/24/2011 21:32'!
testConvertPageWithTable
	| converter |
	self kernel root
		contents:
			'This is a page that contains tables and HTML.
|<span>This is HTML</span>|This is not
'.
	converter := Pier1ToPier2Converter new kernel: self kernel.
	converter convertPage: self kernel root.
	self
		assert:
			self kernel root contents
				=
					'This is a page that contains tables and HTML.
| {{{<span>}}}This is HTML{{{</span>}}}|This is not'! !

!Pier1ToPier2ConverterTest methodsFor: 'tests' stamp: 'JohnBorden 8/24/2011 21:32'!
testConvertString
	self assert: (Pier1ToPier2Converter new convertString: '<br />') = '{{{<br />}}}'.
	self
		assert:
			(Pier1ToPier2Converter new
				convertString:
					'Change this <br /> string
= This should not change <br /> because preformatted
another string')
				=
					'Change this {{{<br />}}} string
= This should not change <br /> because preformatted
another string'.
	self
		assert:
			(Pier1ToPier2Converter new convertString: '<div class="First">text</div> and <div class="Second">text</div>')
				= '{{{<div class="First">}}}text{{{</div>}}} and {{{<div class="Second">}}}text{{{</div>}}}'! !

PRLinkTest subclass: #PRCustomLinkTest
	instanceVariableNames: 'originalConversions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRCustomLinkTest commentStamp: 'JCB 2/26/2009 21:55' prior: 0!
A PRCustomLinkTest is is a test for the custom link class.  This uses some private methods of the PRCustomLink to backup the current conversion blocks, and restore them after the test is complete.

Instance Variables
	originalConversions:		<OrderedCollection of Blocks>

originalConversions
	- Backup of the original conversion blocks
!

!PRCustomLinkTest methodsFor: 'private' stamp: 'JCB 2/24/2009 13:33'!
actualClass
	^ PRCustomLink! !

!PRCustomLinkTest methodsFor: 'private' stamp: 'JCB 2/24/2009 13:33'!
referenceString
	^ 'case 12345'! !

!PRCustomLinkTest methodsFor: 'running' stamp: 'JohnBorden 8/24/2011 21:29'!
setUp
	super setUp.
	originalConversions := self actualClass stringToUrlBlocks.
	self actualClass conversions: OrderedCollection new.
	self actualClass
		addConversion: [ :aString | 
			| numbers |
			(('case #*' match: aString)
				and: [ 
					numbers := aString copyFrom: 6 to: aString size.
					(numbers contains: [ :letter | letter isDigit not ]) not ])
				ifTrue: [ 
					numbers asNumber < 12345
						ifTrue: [ 'http://system/old/case/' , numbers , '.asp' ]
						ifFalse: [ 'http://system/new/case/' , numbers , '.st' ] ] ]! !

!PRCustomLinkTest methodsFor: 'running' stamp: 'JCB 2/24/2009 14:03'!
tearDown
	self actualClass conversions: originalConversions.
	super tearDown! !

!PRCustomLinkTest methodsFor: 'testing-parsing' stamp: 'JohnBorden 8/24/2011 21:30'!
testParseCase
	"self debug: #testParseCase"

	| wiki text tree link |
	wiki := '*case 12345*'.
	text := 'case 12345'.
	self
		assert: (self actualClass isValidReference: text);
		deny: (self actualClass isValidReference: 'case 1234a').
	link := (self actualClass new)
		reference: text;
		yourself.
	tree := (PRDocument new)
		add:
				((PRParagraph new)
						add: link;
						yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text.
	self assert: ('*/new/*' match: link url).
	link := (self actualClass new)
		reference: 'case 12344';
		yourself.
	self assert: ('*/old/*' match: link url)! !

PRExternalLink subclass: #PRCustomLink
	instanceVariableNames: ''
	classVariableNames: 'StringToUrlBlocks'
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRCustomLink commentStamp: 'JohnBorden 8/27/2011 09:37' prior: 0!
A PRCustomLink is an external link which can be modified by sudo-admins.  Examples of things that can be added are:
	PRCustomLink addConversion: [:aString || numberPart | 
		(('cc####*' match: aString) and: [(numberPart := aString copyFrom: 3 to: aString size) isAllDigits]) 
			ifTrue: [numberPart asInteger < 24999 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=mobilicity&Load_CC=', numberPart] 
				ifFalse: [numberPart asInteger < 35000 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=Clear&Load_CC=', numberPart] 
					ifFalse: [numberPart asInteger < 45000 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=Vonage&Load_CC=', numberPart]
						ifFalse: [numberPart asInteger < 50000 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=CenturyTel&Load_CC=', numberPart]
						ifFalse: [numberPart asInteger < 75000 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=metroPCS&Load_CC=', numberPart]
							ifFalse: [numberPart asInteger < 85000 ifTrue: ['https://cmicc.corp.amdocs.com/CustCC/CCEntryForm.aspx?CompanyName=Cablevision&Load_CC=', numberPart]
								ifFalse: [numberPart asInteger < 94477 ifTrue: ['http://cmidom1srv/cmi/formsarchive.nsf/ReqNumber/' , (aString asLowercase)]
								ifFalse: [numberPart asInteger < 107968 ifTrue: ['http://cmidom1srv/cmi/forms.nsf/ReqNumber/' , (aString asLowercase)]
									ifFalse: ['https://cmicc.corp.amdocs.com/custcc/CCEntryForm.aspx?CompanyName=Sprint&Load_CC=', numberPart]]]]]]]]]].
	PRCustomLink addConversion: [:aString | (('cc######dr' match: aString) and: [(aString copyFrom: 3 to: 8) isAllDigits])	
			ifTrue: ['http://cmidom1srv/cmi/forms.nsf/ReqNumber/' , (aString asLowercase)]].
	PRCustomLink addConversion: [:aString | (('xc######' match: aString) and: [(aString copyFrom: 3 to: 8) isAllDigits])
			ifTrue: ['http://cmidom1srv/cmi/cingular.nsf/ReqNumber/' , (aString asLowercase)]].
	PRCustomLink addConversion: [:aString | (('Case #*-#*' match: aString)
			and: [| numbers | numbers := (aString copyFrom: 6 to: aString size) findTokens: '-'.  numbers size = 2 and: [(numbers contains: [:aSubString | aSubString isAllDigits not]) not]])	
				ifTrue: ['http://cmiweb1/champs/Subcase_Details.asp?idn=' , (aString copyFrom: 6 to: aString size)]].
	PRCustomLink addConversion: [:aString | (('Case ######*' match: aString) and: [(aString copyFrom: 6 to: aString size) isAllDigits])
			ifTrue: ['http://cmiweb1/champs/Case_Details.asp?idn=' , (aString copyFrom: 6 to: aString size)]].
	PRCustomLink addConversion: [:aString | ('\\cmifs01\*' match: aString) 
			ifTrue: ['file:///' , (aString copy translateWith: ((String withAll: Character allCharacters) at: $\ asciiValue + 1 put: $/; yourself))]].
	PRCustomLink addConversion: [:aString | (('doc *' match: aString) and: [(aString copyFrom: 5 to: aString size) isAllDigits])
			ifTrue: ['http://Docloader/Docloader/docloader.aspx?action=view&docnum=', (aString copyFrom: 5 to: aString size)]].
	PRCustomLink addConversion: [:aString | (('rca ai ##*' match: aString) and: [(aString copyFrom: 8 to: aString size) isAllDigits])
			ifTrue: ['http://cmiweb1/sitepmo/rootCauseAnalysis/rca-issueActionItemEdit.asp?aiid=', (aString copyFrom: 8 to: aString size)]].
	PRCustomLink addConversion: [:aString | (('rca ##*' match: aString) and: [(aString copyFrom: 5 to: aString size) isAllDigits])
			ifTrue: ['http://cmiweb1/sitepmo/rootCauseAnalysis/rca-issueEdit.asp?rcid=', (aString copyFrom: 5 to: aString size)]].
	PRCustomLink addConversion: [:aString | (('kaizen #*' match: aString) and: [(aString copyFrom: 8 to: aString size) isAllDigits])
			ifTrue: ['http://creativity/SpaceDirectory/Sites/LeanAhead/KaiZen/Lists/Kai%20Zen/DispIdea.aspx?ID=', (aString copyFrom: 8 to: aString size)]]..
	PRCustomLink addConversion: [:aString | ('//cmifs01/*' match: aString) 
			ifTrue: ['file:///' , aString]]
!

!PRCustomLink class methodsFor: 'accessing' stamp: 'JohnBorden 8/24/2011 21:28'!
addConversion: aBlock
	aBlock argumentCount = 1
		ifFalse: [ self error: 'This expects a one argument block' ].
	self stringToUrlBlocks add: aBlock! !

!PRCustomLink class methodsFor: 'private-testing' stamp: 'JohnBorden 8/24/2011 21:28'!
conversions: aCollection
	aCollection isCollection
		ifFalse: [ self error: 'The argument must be a collection.' ].
	StringToUrlBlocks := aCollection! !

!PRCustomLink class methodsFor: 'testing' stamp: 'JohnBorden 8/24/2011 21:28'!
isValidReference: aString
	^ self stringToUrlBlocks contains: [ :block | (block value: aString) notNil ]! !

!PRCustomLink class methodsFor: 'accessing' stamp: 'JohnBorden 8/24/2011 21:29'!
stringToUrlBlocks
	StringToUrlBlocks isNil
		ifTrue: [ StringToUrlBlocks := OrderedCollection new ].
	^ StringToUrlBlocks! !

!PRCustomLink methodsFor: 'accessing-dynamic' stamp: 'JohnBorden 8/24/2011 21:28'!
url
	^ (self class stringToUrlBlocks detect: [ :e | (e value: self reference) notNil ]) value: self reference! !

Object subclass: #Pier1ToPier2Converter
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!Pier1ToPier2Converter commentStamp: 'JohnBorden 8/13/2011 22:47' prior: 0!
Pier1ToPier2Converter is used to convert an imported pier 1 kernel to pier 2 syntax, it replaces html tags with {{{<tag>}}} for a set of known tags (see #verbatimToMatch).

An example of how this can be used to convert pages:

| converter persistency |
persistency := PRKernel instances anyOne persistency.
PRKernel instances anyOne persistency: PRNullPersistency new.
converter := Pier1ToPier2Converter new kernel: (PRKernel instances anyOne).
PRKernel instances anyOne root enumerator everything do: [:page | Pier1ToPier2Converter convertPage: page].
PRKernel instances anyOne persistency: persistency

Before running this, one should check that '{{{' should not be found.!

!Pier1ToPier2Converter class methodsFor: 'as yet unclassified' stamp: 'JCB 4/29/2011 23:42'!
convertPage: aPage
	| new |
	new := self new.
	new kernel: aPage kernel.
	new convertPage: aPage! !

!Pier1ToPier2Converter methodsFor: 'accessing' stamp: 'JCB 3/31/2011 22:04'!
contextForStructure: aStructure command: aCommand
	| context |
	context := PRContext kernel: self kernel structure: aStructure command: aCommand.
	context propertyAt: #user put: (context kernel users select: [ :e | e isSuperuser ]) anyOne.
	^ context! !

!Pier1ToPier2Converter methodsFor: 'actions' stamp: 'JohnBorden 8/24/2011 19:08'!
convertLine: aString
	| resultsBeforeTableFix |
	aString isEmpty
		ifTrue: [ ^ '' ].
	aString first = $=
		ifTrue: [ ^ aString ]
		ifFalse: [ 
			resultsBeforeTableFix := self verbatimToMatch copy: aString translatingMatchesUsing: [ :match | '{{{' , match , '}}}' ].
			resultsBeforeTableFix first = $|
				ifTrue: [ 
					resultsBeforeTableFix := '\|{{{<' asRegexIgnoringCase
						copy: resultsBeforeTableFix
						translatingMatchesUsing: [ :ignore | '| {{{<' ] ].
			^ resultsBeforeTableFix ]! !

!Pier1ToPier2Converter methodsFor: 'actions' stamp: 'JohnBorden 8/13/2011 22:20'!
convertPage: aStructure
	| command context document |
	command := PREditCommand new.
	context := self contextForStructure: aStructure command: command.
	aStructure hasDocument
		ifTrue: [ 
			document := PRPage descriptionDocument fromString: (self convertString: aStructure contents).
			command write: document using: PRPage descriptionDocument.
			command execute ]! !

!Pier1ToPier2Converter methodsFor: 'actions' stamp: 'JohnBorden 8/24/2011 18:47'!
convertString: aString
	^ String
		new: aString size
		streamContents: [ :lines | aString lines do: [ :line | lines nextPutAll: (self convertLine: line) ] separatedBy: [ lines cr ] ]! !

!Pier1ToPier2Converter methodsFor: 'accessing' stamp: 'JCB 3/31/2011 06:40'!
kernel
	^ kernel! !

!Pier1ToPier2Converter methodsFor: 'accessing' stamp: 'JCB 3/31/2011 06:40'!
kernel: aKernel
	kernel := aKernel! !

!Pier1ToPier2Converter methodsFor: 'accessing' stamp: 'JohnBorden 8/24/2011 19:56'!
verbatimToMatch
	^ '<br[^>]*>|<hr[^>]*>|<ol[^>]*>|<ul[^>]*>|<li[^>]*>|</li>|</ul>|</ol>|<blockquote[^>]*>|</blockquote>|<span[^>]*>|</span>|<div[^>]*>|</div>|<img[^>]*>|</img>|&#[0-9]*;|&lt;|&gt;|<font[^>]*>|</font>|<marquee[^>]*|</marquee>|<i>|</i>|<b>|</b>|<pre>|</pre>|<code[^>]*>|</code>'
		asRegexIgnoringCase! !
